if not PlayerOptions.TanDrunk then return Def.ActorFrame {} end

-- store important variables that we might use commonly from _G
local _ENV = {
	_G = _G,
	setmetatable = setmetatable,
	getmetatable = getmetatable,
	rawget = rawget,
	print = print,
	ipairs = ipairs,
	pairs = pairs,
	type = type,
	tonumber = tonumber,
	error = error,
	tostring = tostring,
	GAMESTATE = GAMESTATE,
	SCREENMAN = SCREENMAN,
	PREFSMAN = PREFSMAN,
	STATSMAN = STATSMAN,
	PlayerOptions = PlayerOptions,
	Def = Def,
}

_ENV.dir = _ENV.GAMESTATE:GetCurrentSong():GetSongDir()
_ENV.song = _ENV.GAMESTATE:GetCurrentSong()
-- cache return values of lua files so we avoid loading new instances if the same file is called multiple times
local filecache = {}
function _ENV.loadfile(path)
	if filecache[path] then
		return filecache[path]
	end
	local chunk, err = _G.loadfile(_ENV.dir .. path)
	-- error out with the correct file instead of pointing to this function definition
	if err then error(err, 2) return end
	if setfenv then setfenv(chunk, _ENV) end
	filecache[path] = chunk()
	return filecache[path]
end
function _ENV.module(module)
	return _ENV.loadfile('sm5/modules/' .. module .. '.lua')
end
_ENV._ENV = _ENV

return Def.ActorFrame {
	InitCommand = function(self)
		_ENV.self = self
		_ENV.loadfile'sm5/core/main.lua'
	end,
	OnCommand = function(self)
		_ENV.screen = _ENV.SCREENMAN:GetTopScreen()
		self:playcommand'ScreenReady'
	end,

	Def.Quad {Name="quad"},
}