local mods = {}
local DEG_TO_RAD = pi / 180

-- ret reverse, zigzagperiod, zigzagoffset, zigzag
mods.colrotation = function(deg)
	if deg % 360 == 0 then return 0, 0, 0, 0 end
	if deg % 180 == 0 then return 100, 0, 0, 0 end
	local theta = deg * DEG_TO_RAD
	return 50 - 50 * cos(theta), 1250, -212.5, -1000 * sin(theta)
end

-- x + y
local rot_const1 = sqrt(pow(sw / 2, 2) + pow(sh / 2, 2))
-- rotationz
local rot_const2 = 180 + deg(atan(sh / sw))

-- ret x, y, rotz, zoom
mods.screenrotation = function(ang, x, y, zoom)
	x = x or scx
	y = y or scy
	zoom = zoom or 1
	return x + (rot_const1 * zoom * cos((ang + rot_const2) / 180 * pi)),
	y + (rot_const1 * zoom * sin((ang + rot_const2) / 180 * pi)),
	ang,
	zoom
end

-- auto multi axis compatible counter rotation via funny math
-- ret confusionxoffset, confusionyoffset, confusionoffset
mods.counterrotate = function(rx, ry, rz)
	rx, ry, rz = rx * DEG_TO_RAD, ry * DEG_TO_RAD, rz * DEG_TO_RAD
	local sx, cx = sin(rx), cos(rx)
	local sy, cy = sin(ry), cos(ry)
	local sz, cz = sin(rz), cos(rz)

	return atan2(-cx * sy * sz - sx * cz, cx * cy) * 100, asin(-cx * sy * cz + sx * sz) * 100, atan2(-sx * sy * cz - cx * sz, cy * cz) * 100
end

return mods